#############################################################
# Ausgabe der Hilfe
proc ThelpHelp {helpfile {xPos 100}  {yPos 40} } {

    set w .info
    destroy $w

#   DSNewWindow "." $w "Dromeg: Hilfefenster"  100 40
    DSNewWindow "." $w "Dromeg: Hilfefenster"  $xPos $yPos

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

#    text $w.text -relief raised -bd 2 -yscrollcommand "$w.scroll set"
    text $w.text -bd 2 -yscrollcommand "$w.scroll set" -wrap word \
	-width 80 -height 23 -background grey -spacing2 2 
    pack $w.text -in $w.f1 -side left
    scrollbar $w.scroll -command "$w.text yview"
    pack $w.scroll -in $w.f1 -side right -fill y

    set helpFile [open $helpfile]
	set i 0
	while { [gets $helpFile Zeile] >= 0} {
	    incr i
	    $w.text insert end [string range "$Zeile\n" 1 end]
	    if {[string range $Zeile 0 0] == "H"} then {
		$w.text tag add gross $i.0 $i.end
	    } elseif {[string range $Zeile 0 0] == "R" || \
	    [string range $Zeile 0 0] == "M" || \
	    [string range $Zeile 0 0] == "s" || \
	    [string range $Zeile 0 0] == "S"} then {
		set j 1
		while {[string first "	" \
		[string range $Zeile $j end] ] == 0} {
		    set j [expr $j+1]
		}
		
		if {[string range $Zeile 0 0] == "S"} then {
		    $w.text tag add boldsunken $i.[expr $j-1] $i.end
		} elseif {[string range $Zeile 0 0] == "s"} then {
		    $w.text tag add sunken $i.[expr $j-1] $i.end
		} else {
		    $w.text tag add raised $i.[expr $j-1] $i.end
		}
		if {[string range $Zeile 0 0] == "M"} then {
		    $w.text tag add menu $i.[expr $j-1] $i.end
		}
	    } elseif {[string range $Zeile 1 7] == "	o  "} then {
		$w.text tag add mark $i.4 $i.5
	    } elseif {[string range $Zeile 1 3] == "o  "} then {
		$w.text tag add mark $i.0 $i.1
	    }
	}
    close $helpFile
    $w.text tag configure gross -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure mark -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure menu -background orange 
    $w.text tag configure raised -relief raised -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2
#	    -font -*-courier-*-*-*--*-*-*-*-m-*-*-* 
    $w.text tag configure boldsunken -relief sunken -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2 \
	    -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure sunken -relief sunken -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2 


    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#############################################################
# Ausgabe der Versions-Nummer 
proc ThelpCopyright {programName} {

    set w .info
    destroy $w

    DSNewWindow "." $w "Dromeg: Copyright-Fenster"  100 40

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

    text $w.text -relief raised -bd 2 -yscrollcommand "$w.scroll set" \
	-width 80 -height 23
    pack $w.text -in $w.f1 -side left
    scrollbar $w.scroll -command "$w.text yview"
    pack $w.scroll -in $w.f1 -side right -fill y

    $w.text insert end "Programm $programName\n"
    $w.text insert end "Copyright by Volker Jaekel 1999, 2000, 2002\n\n"
    $w.text insert end "1) Dieses Programm darf nur unter dem Namen $programName verwendet werden.\n"
    $w.text insert end "     Der Nutzer verpflichtet sich, bei Veroeffentlichungen von Ergebnissen,\n"
    $w.text insert end "     die er mit Hilfe dieses Programms erarbeitet hat, die Dissertation"
    $w.text insert end "\n"
    $w.text insert end "	     Einteilung einer eben bewegten Ebene in Felder"
    $w.text insert end " mit qualitativ gleichen \n		Koppelpunktbahnen"
    $w.text insert end " unter besonderer Beruecksichtigung der"
    $w.text insert end " Uebergangskurve\n"
    $w.text insert end "      zu zitieren\n"
    $w.text insert end "\n"
    $w.text insert end "2) Das Kopieren dieses Programms fuer kommerzielle Zwecke ist verboten.\n"
    $w.text insert end "     Unter kommerziellen Zwecken soll an dieser Stelle das Kopieren fuer ein\n"
    $w.text insert end "     Entgeld verstanden werden, dass die Kosten des Informationstraegers uebersteigt.\n"
    $w.text insert end "     Die Nutzung des Programms zum Entwickeln kommerziell genutzter Getriebe\n"
    $w.text insert end "     ist ausdruecklich erlaubt\n"
    $w.text insert end "\n"
    $w.text insert end "3) Das Kopieren des geaenderten Quellcodes dieses Programms ist verboten.\n"
    $w.text insert end "     Zum Aufheben des Verbots muss der geaenderte Quellcode an Volker Jaekel\n"
    $w.text insert end "     (V.Jaekel@t-online.de) geschickt werden. Im Copyright des geaenderten\n"
    $w.text insert end "     Quellcodes muss auf dieses Programm und dessen Copyright verwiesen werden.\n"
    $w.text insert end "     Es ist nicht erlaubt, den geaenderten Quellcode fuer.\n"
    $w.text insert end "     kommerzelle Zwecke entsprechend Punkt 2) zu verwenden.\n"
    $w.text insert end "\n"

    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#############################################################
# Ausgabe der Versions-Nummer 
proc ThelpVersion {programName programVersion} {

    set w .info
    destroy $w

    DSNewWindow "." $w "Dromeg: Infofenster"  100 40

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

    text $w.text -relief raised -bd 2 -width 65 -height 26
    pack $w.text -in $w.f1 -side left

    $w.text insert end "Programm $programName\n"
    $w.text insert end "Version $programVersion\n\n"
    $w.text insert end "Erstellt Anfang 1999\n"
    $w.text insert end "Modifiziert: 2000, 2002\n"
    $w.text insert end "Getestet unter WindowsNT, Windows2000, Solaris 2.6 \n\n"
    $w.text insert end "Copyright by Volker Jaekel\n\n"
    $w.text insert end "eMail: v.jaekel@t-online.de\n"
    $w.text insert end "updates: http://home.t-online.de/home/v.jaekel\n\n"
    $w.text insert end "Die Theorie zu diesem Programm ist zu lesen"
    $w.text insert end " in der 1999\n"
    $w.text insert end "von Volker Jaekel an der Universitaet"
    $w.text insert end " Siegen eingereichten Dissertation:\n"
    $w.text insert end "Einteilung einer eben bewegten Ebene in Felder"
    $w.text insert end " mit qualitativ gleichen \nKoppelpunktbahnen"
    $w.text insert end " unter besonderer Beruecksichtigung der"
    $w.text insert end " Uebergangskurve.\n"
    $w.text insert end "Fortschritt-Berichte VDI, Reihe 1, Nr. 324,\n"
    $w.text insert end " VDI Verlag GmbH, Duesseldorf 2000\n"
    if {$programName != "DROMEG-T"} then {   
        $w.text insert end "\n"
        $w.text insert end "sowie in dem Beitrag\n"
        $w.text insert end "Zielgefuehrte Simulation zum Auffinden von Koppelpunkten fuer das Antreiben "
        $w.text insert end "von totalschwingfaehigen Doppelschwingen\n" 
        $w.text insert end "erschienen im VDI-Bericht 1707\n"
        $w.text insert end "Kurvengetriebe, Koppelgetriebe, gesteuerte Antriebe, Seite 145-164\n"
        $w.text insert end "VDI-Verlag Duesseldorf 2002\n"
        $w.text insert end "(Begleittext zur Getriebetagung 2002)" 
    }

    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#################################################################
proc DSNewWindow {w wn title x y} {
# w	Variable des Parent-Windows
# wn	Variable des Neuen Windows
# title Name des neuen Fensters
# x	Position des neuen Fensters in x-Richtung 
# y	Position des neuen Fensters in y-Richtung 

    set parentPosition [wm geometry $w]
    set xstart [expr [string first "+" $parentPosition]+1]
    set xstring [string range $parentPosition $xstart end]
    set xend [expr [string first "+" $xstring]-1]
    set xpos [string range $xstring 0 $xend]
    set ystart [expr $xend+2]
    set ypos [string range $xstring $ystart end]
#   set geometry "+[expr $xpos+100]+[expr $ypos+40]"
    set geometry "+[expr $xpos+$x]+[expr $ypos+$y]"

    toplevel $wn
    wm geometry $wn "$geometry"
    wm focus $wn
    wm title $wn $title
    wm transient $wn $w
    wm group $wn $w 
}
#############################################################
proc xLiesKnotenMittelpunkt {wc Knoten} {
set Alt [$wc coords $Knoten]
return [expr ( [lrange $Alt 0 0] + [lrange $Alt 2 2] )/2]
}
######################################################
proc yLiesKnotenMittelpunkt {wc Knoten} {
set Alt [$wc coords $Knoten]
return [expr ( [lrange $Alt 1 1] + [lrange $Alt 3 3] )/2]
}
######################################################
proc Knoten {wc x y tag} {     ;# Erzeugt neuen Knoten bei (x,y)
global KnotenX KnotenY KanteVon KanteNach pradi_
set Knoten [$wc create oval [expr $x-$pradi_] [expr $y-$pradi_] \
		       [expr $x+$pradi_] [expr $y+$pradi_] \
		       -outline black -fill white \
		       -tags $tag]
$wc addtag Knoten withtag $Knoten
set KnotenX($Knoten) $x
set KnotenY($Knoten) $y
set KanteVon($Knoten) {}
set KanteNach($Knoten) {}
}
######################################################
proc Kante {wc von nach tag tag2} { ;# Erzeugt Kante zwischen Knoten
global KnotenX KnotenY KanteVon KanteNach
set Kante [$wc create line $KnotenX($von) $KnotenY($von) \
$KnotenX($nach) $KnotenY($nach) \
		      -tags $tag]
$wc addtag $tag2 withtag $Kante
$wc addtag $tag2- withtag $Kante
$wc lower $Kante
lappend KanteVon($von) $Kante
lappend KanteNach($nach) $Kante
return $Kante
}
######################################################
proc VerschiebeKnoten {wc Knoten xDist yDist} {
global KnotenX KnotenY KanteVon KanteNach
$wc move $Knoten $xDist $yDist
set KnotenX($Knoten) [expr $KnotenX($Knoten)+$xDist]
set KnotenY($Knoten) [expr $KnotenY($Knoten)+$yDist]
foreach Kante $KanteVon($Knoten) {
$wc coords $Kante $KnotenX($Knoten) $KnotenY($Knoten) \
    [lindex [$wc coords $Kante] 2] \
    [lindex [$wc coords $Kante] 3] 
}
foreach Kante $KanteNach($Knoten) {
$wc coords $Kante \
    [lindex [$wc coords $Kante] 0] \
    [lindex [$wc coords $Kante] 1] \
    $KnotenX($Knoten) $KnotenY($Knoten)
}
}
#############################################################
proc VPostscript {} {
    global plotName plotName_old 

    set plotName_old $plotName

    TCreateEntryButton " " {$wc postscript -file $plotName} \
	{set plotName $plotName_old} 30 \
	{"Dateiname:" plotName} 
    TShowSubwindow  {100} {40} {Plot-Datei erstellen}
}
#############################################################
proc TZoomOut {} {

    global massstab last_massstab xMoveto last_xMoveto yMoveto
    global last_yMoveto 0x last_0x 0y last_0y

    set last_massstab $massstab
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y
    set faktor 2.
    TChangeZoom $faktor
}
#############################################################
proc TZoomLast {} {

    global wc massstab last_massstab xMoveto yMoveto 
    global last_xMoveto last_yMoveto 0x 0y last_0x last_0y

    set dummy $massstab
    set massstab $last_massstab
    set last_massstab $dummy
    set dummy $xMoveto
    set xMoveto $last_xMoveto
    set last_xMoveto $dummy
    set dummy $yMoveto
    set yMoveto $last_yMoveto
    set last_yMoveto $dummy
    set dummy $0x
    set 0x $last_0x
    set last_0x $dummy
    set dummy $0y
    set 0y $last_0y
    set last_0y $dummy

    TSetZoomFenster_special

    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
}
#############################################################
proc TChangeZoom {faktor} {
    global massstab
    global xZoomPos1 canvas_width 0x xneu xzoom
    global yZoomPos1 canvas_height 0y yneu yzoom

    set massstab [expr $massstab/$faktor]

    set delta [expr ($faktor-1.)/2.]
    set xZoomPos1 [expr -$canvas_width*$delta]
    set yZoomPos1 [expr $canvas_height+$canvas_height*$delta]
    set xzoom [expr $xZoomPos1-$0x]
    set yzoom [expr $yZoomPos1-$0y]
    set xneu [expr $canvas_width+$canvas_width*$delta]
    set yneu [expr -$canvas_height*$delta]

    TSetZoomFenster_special

    TZoomMoveto
}
#############################################################
proc xyViewDefault {} {
    global wc xregion_ yregion_ canvas_width canvas_height
    global xMoveto yMoveto last_xMoveto last_yMoveto 0x 0y
    global last_0x last_0y

    set last_0x $0x
    set last_0y $0y
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set 0x [expr $canvas_width/2.]
    set 0y [expr $canvas_height/2.]
    set xMoveto [expr 1./$xregion_*($xregion_/2.-$0x)]
    set yMoveto [expr 1./$yregion_*($yregion_/2.-$0y)]
    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
}
#############################################################
proc TSetZoomFenster {} {

# xzoom,yzoom: Koordinaten in "Getriebekoordinaten" des 1. Punktes des
#	       Zoom-Rechtecks
# xneu,yneu:   Koordinaten in "Getriebekoordinaten" des 2. Punktes des
#	       Zoom-Rechtecks
# 0x,0y:       Ursprung der "Getriebekoordinaten" in Koordinaten des
#	       Bildschirms (Ursprung oben links)
# xMoveto:     Position des linken randes des Bildauschnitts relativ
#	       zu $xregion_ als Zahlenwert zwischen 0 und 1
# xregion_:    Region, die durch verschieben des Bildausschnitts
#	       sichtbar gemacht werden kann, ohne den Massstab zu
#	       aendern

    global massstab wc last_massstab xneu yneu
    global canvas_height canvas_width xzoom yzoom zoom_v 0x 0y
    global statuszeile last_xMoveto last_yMoveto xMoveto yMoveto
    global last_0x last_0y yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2

    set statuszeile "Zoomauschnitt festlegen durch Aufziehen eines \
Rechtecks bei gedrueckter 'linker Maustaste'"
    set last_massstab $massstab
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y

    bind $wc <ButtonPress-1> {
	set xZoomPos1 %x
	set yZoomPos1 %y
	set xzoom [expr $xZoomPos1-$0x]
	set yzoom [expr $yZoomPos1-$0y]
	set xn [expr $xzoom+1]
	set yn [expr $yzoom+1]
	$wc create rectangle $xzoom $yzoom $xn $yn -tags zoom
	set zoom_v [expr double($canvas_width)/double($canvas_height)]
    }
    bind $wc <B1-Motion> {
	set xZoomPos2 %x
	set yZoomPos2 %y
	set xneu [expr $xZoomPos2-$0x]
	set yneu [expr $yZoomPos2-$0y]
	if {[expr ($xneu-$xzoom)*($yneu-$yzoom)] > 0} then {
	    set sign -1.
	} else {
	    set sign 1.
	}
	if {[expr abs($xneu-$xzoom)/$canvas_width] > \
	[expr abs($yneu-$yzoom)/$canvas_height]} then {
	    set yneu [expr $yzoom+$sign*($xzoom-$xneu)/$zoom_v]
	    set yZoomPos2 [expr $yZoomPos1+\
		$sign*($xZoomPos1-$xZoomPos2)/$zoom_v]
	} else {
	    set xneu [expr $xzoom+$sign*($yzoom-$yneu)*$zoom_v]
	    set xZoomPos2 [expr $xZoomPos1+\
		$sign*($yZoomPos1-$yZoomPos2)*$zoom_v]
	}
	$wc coords zoom $xzoom $yzoom $xneu $yneu
    }
    bind $wc <ButtonRelease-1> {
	$wc delete zoom
	bind $wc <ButtonPress-1> {}
	bind $wc <B1-Motion> {}
	bind $wc <ButtonRelease-1> {}
	if {$xneu < $xzoom} then {
	    set dummy $xneu
	    set xneu $xzoom
	    set xzoom $dummy
	    set dummy $xZoomPos2
	    set xZoomPos2 $xZoomPos1
	    set xZoomPos1 $dummy
	}
	if {$yneu > $yzoom} then {
	    set dummy $yneu
	    set yneu $yzoom
	    set yzoom $dummy
	    set dummy $yZoomPos2
	    set yZoomPos2 $yZoomPos1
	    set yZoomPos1 $dummy
	}
	set massstab [expr double($canvas_width)/abs($xneu-$xzoom)\
	    *$massstab]
	TSetZoomFenster_special
	TZoomMoveto
	set statuszeile ""
    }
}
#############################################################
proc TZoomMoveto {} {
    global massstab wc last_massstab xneu yneu
    global canvas_height canvas_width xzoom yzoom 0x 0y
    global xMoveto yMoveto xregion_ yregion_
    global yZoomPos1 xZoomPos1

	set xLinkerRand [expr $xMoveto*$xregion_]
	set xMoveto [expr 1./$xregion_*\
	    ($xLinkerRand+$xZoomPos1+$xzoom/$last_massstab*$massstab\
	    -$xzoom)]

	set yObererRand [expr $yMoveto*$yregion_]
	set yMoveto [expr 1./$yregion_*\
	    ($yObererRand+$yZoomPos1+$yzoom/$last_massstab*$massstab\
	    -$yzoom-$canvas_height)]

	$wc xview moveto $xMoveto
	$wc yview moveto $yMoveto

	set 0x [expr -$xzoom/$last_massstab*$massstab]
	set 0y [expr $canvas_height-$yzoom/$last_massstab*$massstab]
}
#############################################################
proc min {a b} {
    if {$a< $b} then {
	return $a
    } else {
	return $b
    }
}
#############################################################
proc max {a b} {
    if {$a> $b} then {
	return $a
    } else {
	return $b
    }
}
#############################################################
proc TSetMassstab {} {

    global massstab massstab_old last_massstab
    global last_massstab_old
    global last_xMoveto_old last_xMoveto 
    global last_yMoveto_old last_yMoveto
    global last_0x_old last_0x last_xMoveto xMoveto 0x
    global last_0y_old last_0y last_yMoveto yMoveto 0y
    global TSetMassstabAbbruch

    set last_xMoveto_old $last_xMoveto 
    set last_yMoveto_old $last_yMoveto 
    set last_massstab_old $last_massstab
    set last_massstab $massstab
    set massstab_old $massstab

    set last_0x_old $last_0x
    set last_0y_old $last_0y
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y

    set TSetMassstabAbbruch "no"

    TCreateEntryButton " " {\
	set faktor [expr double($last_massstab)/double($massstab)]
	set massstab $last_massstab
	TChangeZoom $faktor
	set last_massstab $massstab
	if {$TSetMassstabAbbruch =="yes"} then {
	    set 0x $last_0x
	    set 0y $last_0y
	    set xMoveto $last_xMoveto 
	    set yMoveto $last_yMoveto 
	    set last_xMoveto $last_xMoveto_old 
	    set last_yMoveto $last_yMoveto_old 
	    set last_massstab $last_massstab_old
	    set last_0x $last_0x_old
	    set last_0y $last_0y_old
	} } \
	{set massstab $massstab_old
	set TSetMassstabAbbruch "yes"} 6 \
	{"Massstab:" massstab}
     TShowSubwindow  {100} {40} {Massstab}
}
#############################################################
proc TSetGrafikGroesse {} {
    global canvas_height canvas_width xregion_ yregion_
    global canvas_height_old canvas_width_old

    set canvas_width_old $canvas_width
    set canvas_height_old $canvas_height

    TCreateEntryButton " " \
	{$wc configure -height $canvas_height -width $canvas_width
	xyViewDefault} \
	{set canvas_width $canvas_width_old
	 set canvas_height $canvas_height_old} 6 \
	{"Breite des Grafikfensters in Pixel:" canvas_width} \
	{"Hoehe des Grafikfensters in Pixel:" canvas_height}

    TShowSubwindow  {100} {40} {Fenstergroesse}
}
#############################################################
proc TCreateEntryButton {help befehl abbruch width args} {
 
    set t .toplevelpara
    destroy $t
    toplevel $t

    set i 0
    foreach line $args {
	set i [expr $i+1]
	set text [lrange $line 0 0]
	set auch_leerzeichen [string first " " $text]
	if {$auch_leerzeichen > -1} then {
	    set length [expr [string length $text]-2]
	    set text [string range $text 1 $length]
	}
	set var [lrange $line 1 1]

	frame $t.$i
	pack $t.$i -in $t -side top -fill x

	label $t.$i.l -text $text
	entry $t.$i.e -textvariable $var -width $width
	pack $t.$i.l -in $t.$i -side left
	pack $t.$i.e -in $t.$i -side right
	bind $t.$i.e <Return> "$befehl"
    }

    set i [expr $i+1]
    frame $t.$i
    pack $t.$i -in $t -side top -fill x

    label $t.$i.l -text " "

    if {$help != " "} then {
	button $t.$i.help -text Hilfe -foreground blue -command "$help"
    }

    button $t.$i.abbruch -text Abbruch -command "
	$abbruch 
	$befehl
	wm withdraw .toplevelpara 
    "
    button $t.$i.try -text Versuchen -command "$befehl"
    button $t.$i.ok -text OK -command " 
	$befehl
	wm withdraw .toplevelpara 
    "
    label $t.$i.r -text " "

    pack $t.$i.l -in $t.$i -side left -expand 1
    pack $t.$i.ok $t.$i.try $t.$i.abbruch -in $t.$i -side left
    if {$help != " "} then {
	pack $t.$i.help -in $t.$i -side left -expand 1
    }
    pack $t.$i.r -in $t.$i -side left -expand 1
}
##########################################################
proc TShowSubwindow {x y wtitle} {

    set t .toplevelpara
    set parentPosition [wm geometry .]
    set xstart [expr [string first "+" $parentPosition]+1]
    set xstring [string range $parentPosition $xstart end]
    set xend [expr [string first "+" $xstring]-1]
    set xpos [string range $xstring 0 $xend]
    set ystart [expr $xend+2]
    set ypos [string range $xstring $ystart end]
    
    set geometry "+[expr $xpos+$x]+[expr $ypos+$y]"
    wm geometry $t $geometry
    focus $t
    wm title $t $wtitle
    wm transient $t .
    wm group $t . 
}
#############################################################
proc T_Grafik {} {
    global canvas_height canvas_width wc xMax_ yMax_ xregion_ yregion_

    destroy .chscroll
    destroy .cvscroll
    destroy $wc

    scrollbar .chscroll -orient horiz -command "$wc xview"
    scrollbar .cvscroll -command "$wc yview"
    set xregion_ [expr $canvas_width*20]
    set yregion_ [expr $canvas_height*20]
    canvas $wc -relief sunken -borderwidth 2 -scrollregion \
	"[expr -$xregion_/2] [expr -$yregion_/2] [expr $xregion_/2] [expr $yregion_/2]" \
	-height $canvas_height -width $canvas_width \
	-xscrollcommand ".chscroll set" -yscrollcommand ".cvscroll set"

    pack .chscroll -in .c -expand yes -fill x -side bottom
    pack $wc -expand yes -fill both -padx 1 -pady 1 -in .c -side left
    pack .cvscroll -in .c -side right -expand yes -fill y

    T_Grafik_special

}
#################################################################
# Prozedur erst verlassen, wenn durch fehlermelderwartet*
# erzeugtes Fenster verlassen wurde

proc fehlerMelderWarten {} {
    global fehlermelderWartet statuszeile

    set j 0
    while {$j == 0} {
	after 1000
	if {$fehlermelderWartet == 0} then {
	    set j 1
	}
    }
    set statuszeile " "
}
#################################################################
proc fehlermelder2 {fehlermeldung1 fehlermeldung2 {help nohelp} } {

    global fehlermelderWartet
    global statuszeile

	set statuszeile "Programm  pausiert"

	set fehlermelderWartet 1
	set w .err

	destroy $w
	DSNewWindow "." $w "Dromeg: Fehlermelder" 100 40

	frame $w.f1
	frame $w.f2 
	pack $w.f1 $w.f2 -side top -in $w -fill x
	frame $w.f1.f1
	frame $w.f1.f2
	pack $w.f1.f1 $w.f1.f2 -in $w.f1 -fill x
	label $w.f1.f1.l1 -text "Folgender Fehler ist aufgetreten:" \
	    -foreground red
	pack $w.f1.f1.l1 -in $w.f1.f1 -side left
	label $w.f1.f2.l1 -text "$fehlermeldung1"
	label $w.f1.f2.l2 -text " "
	label $w.f1.f2.l3 -text "$fehlermeldung2"
	pack $w.f1.f2.l1 $w.f1.f2.l2 $w.f1.f2.l3 \
	    -in $w.f1.f2 -side top -anchor w

	frame $w.f2.f1 
	button $w.f2.b1 -text "Weiter" -command {
	    set fehlermelderWartet 0
	    destroy .err
	}

	if {$help != "nohelp"} then {
	    button $w.f2.b2 -text "Hilfe" -foreground blue -command "
		ThelpHelp $help 200 200
	    "
	    frame $w.f2.f2 
	    pack $w.f2.f2 -in $w.f2 -expand 1 -side right
	    pack $w.f2.b2 -in $w.f2 -side right
	}

	frame $w.f2.f3
	pack $w.f2.f1 -in $w.f2 -expand 1 -side left
	pack $w.f2.b1 -in $w.f2 -side left
	pack $w.f2.f3 -in $w.f2 -expand 1 -side right

	tkwait variable fehlermelderWartet
}
####################################################################
proc VfileDialog {w operation fileType dir} {

    #	Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    if {"$fileType" == "Getriebeparameter" } then {
	set types {
	    {"Complete-View-Datei"		  {.dcv} }
	    {"Getriebe- & Grafikparameter-Datei"  {.dgg} }
	    {"Getriebeparameter-Datei"		  {.dgp} }
	    {"All files"	    *}
	}
    } else {
	set types {
	    {"Grafikparameter-Datei"	     {.def} }
	    {"All files"	    *}
	}
    }
    #if {[regexp {[a-zA-Z0-9_-]+\.dgg$} $file] == 1} then {
    #	 set postfix dgg
    #} elseif {[regexp {[a-zA-Z0-9_-]+\.def$} $file] == 1} then {
    #	 set postfix def
    #} else {
    #	 set postfix dgp
    #}
    if {$operation == "open"} {
	set file [tk_getOpenFile -filetypes $types -parent $w -initialdir $dir]
    } else {
	set file [tk_getSaveFile -filetypes $types -parent $w \
	    -initialfile dromeg -initialdir $dir -defaultextension .dat]
    }
    return $file
}
#################################################################
proc VGrafikeinstellungSpeichern {programmName typ {operation speichern}} {

    global a a_ iZ_M iZ_A iN_M iN_A iZ iN rR    
    global phi_ phi_grad gamma0_ gam0_grad a_massstab da pradi_ rG_ type_ 
    global showTrochMove showFelder showGestell ischritte_ iT

    global GetrParaDir
    global al1 al2 al3 al4 alkx alky phi1 kbf alz1 alz2 alzx alzy kbz dateiNamePostfix
    global al1ue al2ue al3ue al4ue xSb ySb xUe yUe cl1 cl3
    global dphi
    global dphi_df
    global showRast
    global showGang
    global showSelbst
    global showUeber
    global showKoppelk
    global showKSwBg
    global showFeld
    global showPunktMove
    global fillGang
    global zweiLagen
    global noMomentanPol
    global zweiLagenKoppel
    global eineLage zweiSchlag
    global showSchnabel showZsR showThales
    global al1Snabel al2Snabel al3Snabel al4Snabel
    global showZweiSchlagHodograph showZweischlagWinkelDifferenz
    global massstab xMoveto yMoveto 0x 0y wc
    global last_massstab last_xMoveto last_yMoveto last_0x last_0y
    global yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2 xneu yneu xregion_ yregion_
    global maus1 maus2 maus3 plotName

    set filename [speicherDir]
    if {[file isdirectory $filename] == 1} then {
	if {[file writable $filename] == 1} then {

# Programmspezifische Grafikeinstellungen abspeichern
	    set filename3 $filename
                  if {[string range $filename end end] == "/"} then {
	        append filename3 $programmName.def
                  } else {
                      append filename3 /$programmName.def
                  }
                  if {[string range $filename3 0 0] == "/" || [string range $filename3 1 1] == ":"} then {
                        set filenameX $filename3
                  } else {
                        set pwD [pwd]
                        set filenameX $pwD/$filename3
                  }

	    if {[file exists $filename3] == 1 \
	    && [file writable $filename3] == 0} then {
		fehlermelder2 \
"Die Grafikeinstellungen sollen in der Datei $filename3 gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer die Datei $filenameX"
		fehlerMelderWarten
	    } else {
		if {$typ == "P"} then {
		    if {[info exists GetrParaDir] == 1} then {
			set dir $GetrParaDir
		    } else {
			set dir $filename
		    }
		    set file [VfileDialog "." $operation "Getriebeparameter" $dir]
		    if [string compare $file ""] {
			set dirTest [string last "/" $file]
			if {$dirTest >= 0} then {
			    set GetrParaDir [string range $file 0 $dirTest]
			}
			if {$operation == "speichern"} then {
			    VGetriebeparameterSpeichern $file append
			    if {[regexp {[a-zA-Z0-9_-]+\.dcv$} $file] == 1} then {
				VkueSpeichern $file
				VGrafikeinstellungSpeichern3 $file append
			    } elseif {[regexp {[a-zA-Z0-9_-]+\.dgg$} $file] == 1} then {
				VGrafikeinstellungSpeichern3 $file append
			    }
			} else {
			    source $file
                                              VupdateView
			    #VChangeGetrLaengen
			    #VStatus
			    #VBind
			}
		    }
		    return
		} else {
		    VGrafikeinstellungSpeichern3 $filenameX
		}
	    }

# allgemeine Grafikeinstellungen abspeichern
	    set filename2 $filename
	    append filename2 dromeg.def
	    if {[file exists $filename2] == 1 \
	    && [file writable $filename2] == 0} then {
                            if {[string range $filename2 0 0] == "/" || [string range $filename2 1 1] == ":"} then {
                                set filenameX $filename2
                            } else {
                                set pwD [pwd]
                                set filenameX $pwD/$filename2
                            }

		fehlermelder2 \
"Die Grafikeinstellungen sollen in der Datei $filenameX gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer die Datei $filenameX"
		fehlerMelderWarten
	    } else {
		VGrafikeinstellungSpeichern2 $filename2
	    }
	} else {
	    fehlermelder2 \
"Die Grafikeinstellungen sollen im Verzeichnis $filename gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer das Verzeichnis $filename" \
		dro-fgs4.hlp
	    fehlerMelderWarten
	}
    } else {
               if {[string range $filename 0 0] == "/" || [string range $filename 1 1] == ":"} then {
                                set filenameX $filename
                            } else {
                                set pwD [pwd]
                                set filenameX $pwD/$filename
                            }
	fehlermelder2 \
"Die Grafikeinstellungen sollen im Verzeichnis $filenameX gespeichert werden" \
"Das Verzeichnis $filenameX existiert nicht"
	fehlerMelderWarten
    }
    append filename dromeg.def
}
#############################################################
proc VGrafikeinstellungSpeichern2 {filename} {

    global canvas_height
    global canvas_width
    global plotName

    set Datei [open $filename w+]
	puts $Datei "set canvas_height $canvas_height"
	puts $Datei "set canvas_width $canvas_width"
	puts $Datei "set plotName $plotName"
    close $Datei
}
#############################################################
proc speicherDir {} {

    global env

    if {[info exists env(DROMEG)] == 1} then {
	regsub -all {\\} $env(DROMEG) {/} speicherPfad
	set last [expr [string length $speicherPfad]-1]
	if {[string range $speicherPfad $last $last] != "/"} then {
	    append speicherPfad "/"
	}
    } else {
	set speicherPfad "dat"
    }
    return $speicherPfad
}
#############################################################
