#!/inko4/bin/wish -f
# Analyse von Trochoiden
######################################################
source dromeg-b.tcl
######################################################
proc xTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*cos($phi)+abs($a)*cos($m*$phi+$gamma0_)]
}
######################################################
proc yTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*sin($phi)+abs($a)*sin($m*$phi+$gamma0_)]
}
######################################################
proc createTrochoide {wc iN Pi} {
global a_ rG_ m_ gamma0_ massstab a_massstab
global xyT iT dPhi ischritte_ umdr_

set a_massstab [expr $a_/$massstab]

set umdr_ [expr int($umdr_)]
$wc delete "trochoide$umdr_"
#   set iT 180
set dPhi [expr 2*$Pi/$iT]
set phi  [expr $umdr_*2*$Pi]
set xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
set i 0
while {$i<$iT} {
    set phi [expr $phi+$dPhi]
    lappend xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
    lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
    incr i 1
}
if {$umdr_==0} {
    set rgb1 d
} elseif {$umdr_==4} {
    set rgb1 8
} else {
    set rgb1 0
}
if {$umdr_==1} {
    set rgb2 d
} elseif {$umdr_==5} {
    set rgb2 8
} else {
    set rgb2 0
}
if {$umdr_==2} {
    set rgb3 d
} elseif {$umdr_==6} {
    set rgb3 8
} else {
    set rgb3 0
}
set Befehl \
"$wc create line $xyT -tags trochoide$umdr_ \
    -fill #$rgb1$rgb2$rgb3"
set Line [eval $Befehl]
$wc addtag "Trochoide" withtag $Line
$wc addtag trochoide withtag $Line
}
######################################################
proc modifyTrochoide {wc m_dum iN gamma0 Pi} {
global a_ phi_ m_ rG_
global xyT iT dPhi iN_alt a_massstab massstab umdr_

set a_massstab [expr $a_/$massstab]

set abs_iN [expr abs($iN)]
if {[info exists iN_alt]==0} {set iN_alt 0}
if {$abs_iN>$iN_alt} {
while {$iN_alt<$abs_iN} {
    set umdr_ [expr int($iN_alt)]
    createTrochoide $wc $iN_alt $Pi
    incr iN_alt 1
}
} elseif {$abs_iN<=$iN_alt} {
while {$iN_alt>=$abs_iN} {
    set iN_alt [expr int($iN_alt)]
    $wc delete "trochoide$iN_alt"
    incr iN_alt -1
}
}
set umdr_ 0
while {$umdr_<$abs_iN} {
set phi [expr $umdr_*2*$Pi]
set xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0]
lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0]
set i 0
while {$i<$iT} {
    set phi [expr $phi+$dPhi]
    lappend xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0]
    lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0]
    incr i 1
}
set Befehl "$wc coords trochoide$umdr_ $xyT"
set Line [eval $Befehl]
incr umdr_ 1
}
set xt [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0]
set yt [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0]
VerschiebeKnoten $wc 4 [expr $xt-[xLiesKnotenMittelpunkt $wc 4] ] \
		   [expr $yt-[yLiesKnotenMittelpunkt $wc 4] ]
}
######################################################
proc bewegeGetriebe {wc phi_dum rG_dum rR m_dum a_dum gamma0_ Pi \
    Richtung geschw} {

global a_ phi_ m_ iZ
global rG_ rUe_ phi_grad
global irunMaxI ischritte_

if {$irunMaxI != 0} then {return}

if {$iZ > 0} then {
 set signiZ 1
} else {
 set signiZ -1
}

set i $ischritte_
set dphi [expr 2*$Pi/$i*$Richtung]
set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set xP [expr $signiZ*$rR*cos($phi_)]
set yP [expr $signiZ*$rR*sin($phi_)]
set xG [expr $rG_*$m_*cos($phi_)]
set yG [expr $rG_*$m_*sin($phi_)]
set irunMaxI 100000
set step 0
while {$step<$irunMaxI} {
incr step 1
set phi_ [expr $phi_+$dphi*$geschw]
set phi_grad [expr $phi_/$Pi*180.]
set xneu [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set yneu [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set xPneu [expr $signiZ*$rR*cos($phi_)]
set yPneu [expr $signiZ*$rR*sin($phi_)]
set xGneu [expr $rG_*$m_*cos($phi_)]
set yGneu [expr $rG_*$m_*sin($phi_)]
set dx [expr $xneu-$x]
set dy [expr $yneu-$y]
set dxP [expr $xPneu-$xP]
set dyP [expr $yPneu-$yP]
set dxG [expr $xGneu-$xG]
set dyG [expr $yGneu-$yG]
set x $xneu
set y $yneu
set xP $xPneu
set yP $yPneu
set xG $xGneu
set yG $yGneu
VerschiebeKnoten $wc 4 $dx $dy
VerschiebeKnoten $wc 3 $dxG $dyG
VerschiebeKnoten $wc 2 $dxP $dyP
$wc move gang $dxG $dyG
$wc move ball $dxG $dyG
set dummy 1
while {$dummy<=$rUe_(0)} {
    $wc move kUe$dummy $dxG $dyG
    $wc move kUefill$dummy $dxG $dyG
    set dummy [expr $dummy+1]
}
frame .wait
pack .wait
tkwait visibility .wait
destroy .wait
}
}
######################################################
proc modifyGetriebe {wc rR} {
global phi_ rG_ m_ gamma0_ a_ rB_ rUe_ iZ

if {$iZ > 0} then {
 set signiZ 1
} else {
 set signiZ -1
}

set xR [expr $signiZ*abs($rR)*cos($phi_)]
set yR [expr $signiZ*abs($rR)*sin($phi_)]
$wc coords rast [expr -$rR] [expr -$rR] $rR $rR
VerschiebeKnoten $wc 2 \
[expr $xR-[xLiesKnotenMittelpunkt $wc 2] ] \
[expr $yR-[yLiesKnotenMittelpunkt $wc 2] ]
set xG [expr $rG_*$m_*cos($phi_)]
set yG [expr $rG_*$m_*sin($phi_)]
$wc coords gang [expr $xG-$rG_] [expr $yG-$rG_] \
[expr $xG+$rG_] [expr $yG+$rG_]
$wc coords ball [expr $xG-$rB_] [expr $yG-$rB_] \
[expr $xG+$rB_] [expr $yG+$rB_]
VerschiebeKnoten $wc 3 [expr $xG-[xLiesKnotenMittelpunkt $wc 3] ] \
		   [expr $yG-[yLiesKnotenMittelpunkt $wc 3] ]
set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
VerschiebeKnoten $wc 4 [expr $x-[xLiesKnotenMittelpunkt $wc 4] ] \
		   [expr $y-[yLiesKnotenMittelpunkt $wc 4] ]
    set iU 1
    while {$iU<=$rUe_(0)} {
	$wc coords kUe$iU [expr $xG-$rUe_($iU)] [expr $yG-$rUe_($iU)] \
	[expr $xG+$rUe_($iU)] [expr $yG+$rUe_($iU)]
	$wc coords kUefill$iU [expr $xG-$rUe_($iU)] \
	[expr $yG-$rUe_($iU)] \
	[expr $xG+$rUe_($iU)] [expr $yG+$rUe_($iU)]
	set iU [expr $iU+1]
    }
    $wc delete gestell
    TCreateGestellRast
}
###############################################################
proc calculatePara {iZ_dummy iN_dummy rR} {
global i_ m_ rG_ iZ iN 

if {$iZ<0 && $iN>0} {
if {abs($iZ)<=abs($iN)} then {
    set iZ [expr -($iN+1)]
}
set rR [expr -abs($rR)]
} else {
set rR [expr abs($rR)]
}

set i_ [expr $iZ/$iN]
set m_ [expr $i_+1]
set rG_ [expr $rR*$iN/$iZ]
}
##########################################################
proc setGetriebetyp {iZ iN} {
# Variable iTyp_ mit Namen des Getriebetyps belegen
global iTyp_ 
if {$iZ >0 && $iN >0} {
set iTyp_ Epitrochoide
} elseif {$iZ >0 && $iN <0} {
set iTyp_ Peritrochoide
} elseif {$iZ <0 && $iN >0} {
set iTyp_ Hypotrochoide
} else {
set iTyp_ "nicht definiert"
}
TLowerKurven
}
######################################################
proc calculateKueKb {wc iN iZ Pi rR} {
# Durchmesser von Kue und Kb ermitteln
global m_ rG_ rUe_ rB_ m_ phi_ gamma0_ rB_massstab massstab
global ns0_ ns_ nsUe_ type_ iN_M iZ_M a_massstab
global showFelder nW_

# Mittelpunkt der Uebergangskreise berechnen
set xG [expr $rG_*$m_*cos($phi_)]
set yG [expr $rG_*$m_*sin($phi_)]

set i [expr $iZ/$iN]
if {$iZ >0} {
# Epitrochoide oder Peritrochoide
    set niMax [expr int($iZ/2)]
} else {
# Hypotrochoide
    set niMax [expr int(abs(2*$iN+$iZ)/2)]
}

# Alle Uebergangskreise ni berechnen
set ni [expr $niMax+1]
set ni_old $rUe_(0)
set rUe_(0) [expr $ni-1]
# nicht mehr benoetigte Uebergangskreise entfernen
set dummy $ni_old
while {$dummy>$rUe_(0)} {
    $wc delete "kUe$dummy"
    $wc delete "kUefill$dummy"
    set dummy [expr $dummy-1]
}

# Ballscher Kreis
set rB_ [expr abs($rG_/$m_)]
set rB_massstab [expr $rB_/$massstab]

if {$showFelder == 0} then {
    set dummy $rUe_(0)
    while {$dummy>0} {
         $wc delete "kUe$dummy"
         $wc delete "kUefill$dummy"
         set dummy [expr $dummy-1]
    }
    set rUe_(0) 0
    return
}

while {$ni>1} {
    set ni [expr $ni-1]
    if {$iN<0} {
      set signiN -1
    } else {
      set signiN 1
    }
    set gamma0 [expr -$signiN*$i*$Pi*(0.5-$ni/$iZ)]
    if {$iZ >0 && $iN >0} {
# Epitrochoide
        set PhiMin [expr $Pi/$m_*($i/2-$ni/$iN)]
        set PhiMax [expr -$ni*$Pi/$iZ+$Pi/2]
        set Phi1 [expr $PhiMin+($PhiMax-$PhiMin)/4]
    } elseif {$iZ >0 && $iN <0} {
# Peritrochoide
        set Phi1 [expr $Pi/(2*$iZ*$ni)]
    } elseif {$iZ <0 && $iN >0} {
# Hypotrochoide
        if { [expr abs($iZ/$iN)] < 2 } {
            set Phi1 [expr $Pi/4]
        } else {
            set PhiMin [expr -$ni*$Pi/$iZ+$Pi/2]
            set PhiMax [expr $Pi/$m_*($i/2-$ni/$iN)]
#	    set Phi1 [expr $PhiMin+($PhiMax-$PhiMin)*3/4]
            set Phi1 [expr $PhiMax-($PhiMax-$PhiMin)/4]
        }
    }
    set Phi2 $Phi1
    set Phi1 -1
#set nn 0
    while { [expr abs($Phi1-$Phi2)]>0.000001} {
      set Phi1 $Phi2
      set tanm [expr tan($m_*$Phi1+$gamma0)]
      set tanp [expr tan($Phi1)]
      set Nenner [expr $m_*$m_*(1+$tanm*$tanm)-1-$tanp*$tanp]
      set Phi2 [expr $Phi1-($m_*$tanm-$tanp)/$Nenner]
#set nn [expr $nn+1]
    }
    set cosm [expr cos($m_*$Phi2+$gamma0)]
    if { [expr abs($cosm)]<0.0001 && [expr abs($Phi2)]>0.0001} {
        set sinm [expr sin($m_*$Phi2+$gamma0)]
        set rUe_($ni) [expr abs($rG_*sin($Phi2)/$sinm)]
    } else {
#        set rUe_($ni) [expr abs(-($rR+$rG_)*cos($Phi2)/$cosm)]
        if {$iZ > 0} then {
            set signiZ 1
        } else {
            set signiZ -1
        }
        set rUe_($ni) [expr abs(-($signiZ*$rR+$rG_)*cos($Phi2)/$cosm)]
    }

    set xMin [expr $xG-$rUe_($ni)]
    set yMin [expr $yG-$rUe_($ni)]
    set xMax [expr $xG+$rUe_($ni)]
    set yMax [expr $yG+$rUe_($ni)]
    if {$ni > $ni_old} then {
        $wc create oval $xMin $yMin $xMax $yMax \
           -outline orange$ni -fill orange$ni -tags kUefill$ni
        $wc addtag "kUefill$ni" withtag kUe$ni
        $wc lower kUefill$ni
        $wc create oval $xMin $yMin $xMax $yMax \
          -outline brown  -tags kUe$ni
    } else {
        $wc coords kUe$ni $xMin $yMin $xMax $yMax
        $wc coords kUefill$ni $xMin $yMin $xMax $yMax
    }

    $wc bind kUe$ni <Any-Enter> \
        "TBindUeIn $ni $wc"
    $wc bind kUe$ni <Any-Leave> \
        "TBindUeOut $ni $wc"
    set befehl "$rUe_($ni)"
    $wc bind kUe$ni <Button-1> \
        "setAkUe $rUe_($ni) $wc $Pi"
    $wc bind kUe$ni <Button-3> \
        "setAkUe $rUe_($ni) $wc $Pi"
}

set nW_ [expr 2*$iZ_M]

# Anzahl Schnittpunkte
if {($type_ == "Epitrochoide") || \
($type_ == "Hypotrochoide" && [expr $iZ_M/$iN_M] > 2)} then {
    set ns0_ [expr ($iN_M-1)*$iZ_M]
} else {
    set ns0_ [expr (abs($iN_M-$iZ_M)-1)*$iZ_M]
}
#set ns_ [expr $ns0_+$iZ_M]
set ns_ [expr $ns0_+abs($iZ_M)]
set i 1
while {$i < $rUe_(0)} {
#   set nsUe_($i) [expr abs(int($ns0_+(1+ 2* $i)*$iZ))]
    set nsUe_($i) [expr int(abs($ns0_+(1+ 2* $i)*abs($iZ)))]
    set i [expr $i+1]
}
set i $rUe_(0)
if {$i >0} then {
    if {$iZ_M%2 == 0} then {
#       set nsUe_($i) [expr abs(int([expr $ns0_+2* $i*$iZ]))]
        set nsUe_($i) [expr int(abs([expr $ns0_+2* $i*abs($iZ)]))]
    } else {
#       set nsUe_($i) [expr abs(int($ns0_+(1+ 2* $i)*$iZ))]
        set nsUe_($i) [expr int(abs($ns0_+(1+ 2* $i)*abs($iZ)))]
    }
}

T_KueStatus
TSetSchnittBlue
}
#########################################################
proc TSetSchnittBlue {} {
global type_ iZ_M iN_M a_massstab rUe_ massstab showFelder
global rB_massstab

if {$showFelder== 0} then {
return
}

set i $rUe_(0)
while {$i>0} {
.c.f.ns.u$i configure -foreground black
set i [expr $i-1]
}
.c.f.ns.s1 configure -foreground black
.c.f.ns.s2 configure -foreground black

#Anzahl an Schnittpunkten blau einfaerben
set faerben "not ok"
if {($type_ == "Epitrochoide") || \
($type_ == "Hypotrochoide" && [expr $iZ_M/$iN_M] > 2)} then {
if {[expr abs($a_massstab)]<=$iN_M} then {
    .c.f.ns.s1 configure -foreground Red
    set faerben "ok"
} else {
    set i $rUe_(0)
    while {$i>0} {
	if {[expr abs($rUe_($i)/$massstab)]<[expr abs($a_massstab)]} then {
	    .c.f.ns.u$i configure -foreground Red
	    set faerben "ok"
	    break
	}
	set i [expr $i-1]
    }
}
if {$faerben == "not ok"} then {.c.f.ns.s2 configure -foreground Red}
if {[expr abs($a_massstab)]>[expr abs($rB_massstab)] && \
[expr abs($a_massstab)]<$iN_M } then {
    .c.f.w.l4 configure -foreground Red
    .c.f.w.l2 configure -foreground black
} else {
    .c.f.w.l4 configure -foreground black
    .c.f.w.l2 configure -foreground Red
}
} else {
if {[expr abs($a_massstab)]>=$iN_M} then {
    .c.f.ns.s1 configure -foreground Red
    set faerben "ok"
} else {
    set i $rUe_(0)
    while {$i>0} {
	if {[expr abs($rUe_($i)/$massstab)]>[expr abs($a_massstab)]} then {
	    .c.f.ns.u$i configure -foreground Red
	    set faerben "ok"
	    break
	}
	set i [expr $i-1]
    }
}
if {$faerben == "not ok"} then {.c.f.ns.s2 configure -foreground Red}
if {[expr abs($a_massstab)]<[expr abs($rB_massstab)] && \
[expr abs($a_massstab)]>$iN_M } then {
    .c.f.w.l4 configure -foreground Red
    .c.f.w.l2 configure -foreground black
} else {
    .c.f.w.l4 configure -foreground black
    .c.f.w.l2 configure -foreground Red
}
}
}
#########################################################
proc setAkUe {wert wc Pi} {
global a_ m_ iN rG_
global phi_ gamma0_

set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
if {[expr abs($x)]>[expr abs($y)]} then {
set steigung_old [expr $y/$x]
} else {
set steigung_old [expr $x/$y]
}

set a_ $wert

set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
if {[expr abs($x)]>[expr abs($y)]} then {
set steigung [expr $y/$x]
} else {
set steigung [expr $x/$y]
}

if {[expr $steigung_old*$steigung] < 0} then {
#Gamma0 aenderte sich um 180 Grad
set a_ -$a_
}
modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
TSetSchnittBlue 
}
#############################################################
proc TBindUeOut {ni wc} {
global statuszeile

$wc itemconfigure kUe$ni -width 1
set statuszeile " "
}
#############################################################
proc TBindUeIn {ni wc} {
global statuszeile

$wc itemconfigure kUe$ni -width 2
set statuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf diese Uebergangskurve"
}
#############################################################
proc TPullDownMenu {} {

global type_ rR a_  canvas_height canvas_width massstab iZ iN a_massstab
global rB_massstab rUe_ showTrochMove showFelder kueStatus
global wc Pi m_ gamma0_ last_massstab showGestell
global xMoveto last_xMoveto yMoveto last_yMoveto 0x 0y
global last_0x last_0y xZoomPos1 yZoomPos1 xzoom yzoom xneu yneu
global dromegTVers

set zoomIn [image create bitmap -file dromegzi.xbm]
set zoomOut [image create bitmap -file dromegzo.xbm]
set zoomLast [image create bitmap -file dromegzl.xbm]
set bitmapStop [image create bitmap -file dromegsp.xbm]
set bitmapStart [image create bitmap -file dromegst.xbm]

#set type_ Epitrochoide

destroy .mbar
frame .mbar -relief raised -bd 2
pack .mbar -side top -fill x

menubutton .mbar.file -text Datei -underline 0 -menu .mbar.file.menu 
menubutton .mbar.type -text Getriebe-Typ -underline 0 -menu .mbar.type.menu 
menubutton .mbar.grafik -text Grafik -underline 0 -menu \
.mbar.grafik.menu 
menubutton .mbar.zoom -text Zoom -underline 0 -menu \
	.mbar.zoom.menu 
menubutton .mbar.help -text Hilfe -underline 0 -menu .mbar.help.menu 
    pack .mbar.file .mbar.type .mbar.grafik .mbar.zoom .mbar.help \
	-side left

button .mbar.start -image $bitmapStart -underline 1 \
    -command {TRunTrochoide -1 1}
foreach i "2 3" {
    bind .mbar.start <ButtonPress-$i> \
	".mbar.start configure -relief sunken
	TRunTrochoide -1 $i"
    bind .mbar.start <ButtonRelease-$i> \
	".mbar.start configure -relief raised"
}
bind .mbar.start <Any-Enter> {
    set statuszeile "'linke Maustaste': langsam,\
'mittlere Maustaste': mittel, 'rechte Maustaste': schnell"
}
bind .mbar.start <Any-Leave> {
    set statuszeile ""
}
button .mbar.stop -image $bitmapStop -underline 1 -command \
    {TStopTrochoide}
foreach i "2 3" {
    bind .mbar.stop <ButtonPress-$i> {TStopTrochoide}
}
bind .mbar.stop <Any-Enter> {
    set statuszeile "'alle Maustasten': Animation oder auch \
Berechnung beenden"
}
bind .mbar.stop <Any-Leave> {
    set statuszeile ""
}
button .mbar.space -text " " -relief flat
button .mbar.zoom_o -image $zoomOut -underline 1 -command \
TZoomOut
bind .mbar.zoom_o <Any-Enter> {
    set statuszeile "'linke Maustasten': raus Zoomen"
}
bind .mbar.zoom_o <Any-Leave> {
    set statuszeile ""
}
button .mbar.zoom_i -image $zoomIn -underline 1 -command \
TSetZoomFenster
bind .mbar.zoom_i <Any-Enter> {
    set statuszeile "'linke Maustasten': rein Zoomen (Rechteck aufziehen)"
}
bind .mbar.zoom_i <Any-Leave> {
    set statuszeile ""
}
button .mbar.zoom_l -image $zoomLast -underline 1 -command {TZoomLast}
bind .mbar.zoom_l <Any-Enter> {
    set statuszeile "'linke Maustasten': letzten Zoom wieder anzeigen"
}
bind .mbar.zoom_l <Any-Leave> {
    set statuszeile ""
}

pack .mbar.zoom_l .mbar.zoom_i .mbar.zoom_o .mbar.space \
    .mbar.stop .mbar.start -side right

    menu .mbar.file.menu
    .mbar.file.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mf-t.hlp"
    }
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Speichern: Einstellungen" \
	-command "VGrafikeinstellungSpeichern dromeg-t E"
    .mbar.file.menu add command -label "Speichern: Getriebeparameter" \
	-command "VGrafikeinstellungSpeichern dro-p-t P"
    .mbar.file.menu add command -label "Lesen: Getriebeparameter" \
        -command "VGrafikeinstellungSpeichern dro-p-4 P open"
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Postscript-Datei erstellen" \
        -command {VPostscript}
    .mbar.file.menu add separator
    .mbar.file.menu add command -label Exit -command {
	exit
    }

     menu .mbar.type.menu
    .mbar.type.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mt-t.hlp"
    }
    .mbar.type.menu add separator
    .mbar.type.menu add command -label "Gelenkgetriebe darstellen" -command {source dromeg-4.tcl}
    .mbar.type.menu add separator
    .mbar.type.menu add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    .mbar.type.menu add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    .mbar.type.menu add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType

    menu .mbar.grafik.menu
    .mbar.grafik.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mg-t.hlp"
    }
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Grafikfenstergroesse" \
	-command {TSetGrafikGroesse}
    .mbar.grafik.menu add command -label "Schritte pro Stegumdrehung" \
	-command {TSetSchritte}
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add checkbutton -label "Feldeinteilung zeigen" \
	-variable showFelder -command {TShowFeldeinteilung}
    .mbar.grafik.menu add checkbutton -label "Gestell zeigen" \
	-variable showGestell -command {
	    TShowGestell
    }
    .mbar.grafik.menu add checkbutton -label "Trochoide dynamisch modifizieren" \
	-variable showTrochMove
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Getriebe starten" \
	-command {TRunTrochoide -1 1}
    .mbar.grafik.menu add command -label "Getriebe anhalten" \
	-command {TStopTrochoide}

    menu .mbar.zoom.menu
    .mbar.zoom.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mz-t.hlp"
    }
    .mbar.zoom.menu add separator
    .mbar.zoom.menu add command -label "Einpassen: Alles" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set a [max [expr abs($rB_massstab)] [expr abs($a_massstab)]]
	    if {$rUe_(0)>0} then {
	        set a [max $a [expr abs($rUe_(1))/$massstab]]
	        set a [max $a [expr abs($rUe_($rUe_(0)))/$massstab]]
	    }
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+$a)]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    .mbar.zoom.menu add command -label "Einpassen: Bahn" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+abs($a_massstab))]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    .mbar.zoom.menu add command -label "Einpassen: Gangpolkurve" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set a [max [expr abs($iN)] [expr abs($a_massstab)]]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+$a)]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    .mbar.zoom.menu add separator
    .mbar.zoom.menu add command -label "Zoom: Rechteck aufziehen" \
	-command {TSetZoomFenster}
    .mbar.zoom.menu add command -label "Zoom: Letzter Zoom" \
	-command {TZoomLast}
    .mbar.zoom.menu add command -label "Zoom: raus zoomen" \
	-command {TZoomOut}
    .mbar.zoom.menu add command -label "Zoom: Massstab aendern" \
	-command {TSetMassstab}

     menu .mbar.help.menu
    .mbar.help.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mh-t.hlp"
    }
    .mbar.help.menu add separator
    .mbar.help.menu add command -label "Grundsaetzliches" -command {
	ThelpHelp "dro-gh-t.hlp"
    }
    .mbar.help.menu add command -label "Hinweise zur Bedienoberflaeche" -command {
	ThelpHelp "dro-t.hlp"
    }
    .mbar.help.menu add command -label "Info" -command {
	ThelpVersion "DROMEG-T" $dromegTVers
    }
    .mbar.help.menu add command -label "Copyright" -command {
	ThelpCopyright "DROMEG-T"
    }


    tk_menuBar .mbar mbar.file .mbar.type .mbar.grafik .mbar.zoom \
	.mbar.help
    focus .mbar
}
#############################################################
proc T_Grafik_special {} {
    xyViewDefault
}
#############################################################
proc TSetZoomFenster_special {} {
    global a_ a_massstab massstab

    set a_ [expr $a_massstab*$massstab]
    TSetI
}
#############################################################
proc TShowFeldeinteilung {} {

    global kueStatus wc iN iZ Pi rR m_ gamma0_ showFelder xG yG rB_

    set kueStatus "not ok"

    if {$showFelder == 0} then {
	$wc delete ball
    } else {
	$wc create oval [expr $xG-$rB_] [expr $yG-$rB_] \
            [expr $xG+$rB_] [expr $yG+$rB_] -outline red \
	    -fill GreenYellow  -tags ball
    }

    TStatusFelder
    calculateKueKb $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN
}
#############################################################
proc TSetSchritte {} {

    global ischritte_ ischritte_old iT iT_old
    global wc iN Pi

    set ischritte_old $ischritte_
    set iT_old $iT

    TCreateEntryButton " " {createTrochoide $wc $iN $Pi
	TSetI} {set iT $iT_old
	set ischritte_ $ischritte_old} 6 \
	{"Bewegung: Anzahl Schritte je Stegumdrehung:" ischritte_} \
	{"Darstellung: Anzahl Schritte je Stegumdrehung:" iT}
    TShowSubwindow  {100} {40} {Schritte je Stegumdrehung}
}
#############################################################
proc TSetRr {} {
    global iZ iN rR wc Pi m_ gamma0_ 

    calculatePara $iZ $iN $rR
    calculateKueKb $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN
}
#############################################################
proc TLowerKurven {} {
    global wc type_ iZ iN rUe_ pradi_ rB_ rG_ rR

    if {$type_ == "Epitrochoide"} then {
#	if {[expr abs($iZ)] > [abs($iN)]} then {
	    $wc lower ball
	    $wc lower gang
	    $wc lower rast
	    set kurve 1
	    while {$kurve <= $rUe_(0)} {
		$wc lower kUefill$kurve
		set kurve [expr $kurve+1]
            }
#	} else {
#       }
    } elseif {$type_ == "Peritrochoide"} then {
	set kurve $rUe_(0)
        while {$kurve > 0} {
	    $wc lower kUefill$kurve
            set kurve [expr $kurve-1]
        }
	$wc lower rast
        set diff [expr $rG_-2*(abs($rG_)-abs($rR))]
	set kurve $rUe_(0)
        while {$kurve > 0} {
            if {([expr abs($rUe_($kurve))] < $diff)  ||  \
            ([expr abs($rUe_($kurve))] > [expr abs($rR)/2.])} then {
		$wc lower kUefill$kurve
	    }
	    set kurve [expr $kurve-1]
        }
	$wc lower gang
	$wc lower ball
    } else {
	if {[expr abs($iZ/$iN)] <2} then {
	set kurve 1
        while {$kurve <= $rUe_(0)} {
	    $wc lower kUefill$kurve
            set kurve [expr $kurve+1]
        }
	    $wc lower gang
	    $wc lower rast
	    $wc lower ball
	} else {
	    $wc lower ball
	    $wc lower gang
	    $wc lower rast
	    set kurve 1
	    while {$kurve <= $rUe_(0)} {
		$wc lower kUefill$kurve
		set kurve [expr $kurve+1]
	    }
	}
    }
    if {$pradi_ >= $rB_} then {
	$wc raise ball
    }
    $wc lower rr-
    $wc lower rg_-
}

#############################################################
proc TSetType {} {

    global type_
    global iZ iN m_ gamma0_ wc rR Pi iZ_A iN_A

     if {$type_ == "Peritrochoide"} then {
        if {$iN_A < $iZ_A} then {
 	    set dummy $iN_A
 	    set iN_A $iZ_A
 	    set iZ_A $dummy
        } elseif {$iN_A == $iZ_A} then {
	    set iN_A [expr $iN_A-1]
        }
    } elseif {$type_ == "Hypotrochoide"} then {
        if {$iN_A > $iZ_A} then {
	    set dummy $iN_A
	    set iN_A $iZ_A
	    set iZ_A $dummy
        } elseif {$iN_A == $iZ_A} then {
	    set iZ_A [expr $iZ_A-1]
	}
    }

    TSetI 
}
#############################################################
proc TRunTrochoide {Richtung geschw} {
    global iZ iN m_ gamma0_ wc rR Pi rG_ a_ phi_ statuszeile

    set statuszeile \
	    "'Rechte oder Linke Maustaste' halten Getriebe an"
    $wc bind Trochoide <Button-3> { TStopTrochoide }
    $wc bind Trochoide <Button-1> { TStopTrochoide }

    bewegeGetriebe $wc phi_ $rG_ $rR $m_ $a_ $gamma0_ $Pi $Richtung \
	$geschw
    calculatePara $iZ $iN $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
}
#############################################################
proc TStopTrochoide {} {
    global wc irunMaxI statuszeile

#   set statuszeile "'Rechte Maustaste' startet Getriebe im \
Uhrzeigersinn, 'Linke Maustaste' im Gegenuhrzeigersinn"
    set irunMaxI 0
#   $wc bind Trochoide <Button-1> { TRunTrochoide -1 1}
#   $wc bind Trochoide <Button-3> { TRunTrochoide +1 1}
}
#############################################################
proc TLeaverRrGKorTrochoide {ibind wc} {
    global pradi_ statuszeile rR rG_ rB_

#    set tag [$wc gettags current]
    set tag $ibind
    $wc itemconfigure [lrange $tag 0 0] -width 1
    $wc raise Knoten
    if {$pradi_ >= $rB_} then {
	$wc raise ball
    }
    set tag2 [string tolower [lrange $tag 0 0] ] 
    $wc itemconfigure $tag2 -arrow none
    if {$tag2 != "k"} then {$wc lower $tag2-}
    
    set statuszeile " "
#    if {($ibind == "rR") || ($ibind == "rG_")} then {
#        TSetrRrGwidth2 
#    }
}
#############################################################
#proc TSetrRrGwidth2 {} {
#    global rR rG_  wc
#
#    if {$rR < $rG_} then {
#	$wc raise rr
#	$wc itemconfigure rr -width 2
#    } else {
#	$wc raise rg_
#	$wc itemconfigure rg_ -width 2
#    }
#}
#############################################################
proc TRaiserRrGKorTrochoide {ibind wc} {
    set tag $ibind
    $wc itemconfigure [lrange $tag 0 0] -width 2 
    $wc raise [string tolower [lrange $tag 0 0] ]
    $wc itemconfigure [string tolower [lrange $tag 0 0] ] \
 	    -arrow last
}
#############################################################
proc TEnterrRrGKorTrochoide {ibind wc} {
        global irunMaxI statuszeile
#        set tag [$wc gettags current]
        TRaiserRrGKorTrochoide $ibind $wc
        if {$ibind == "rR"} then {
            set statuszeile "'Linke Maustaste' vergroessert Radius \
der Rastpolkurve, 'Rechte Maustaste' verkleinert ihn"
        } elseif {$ibind == "rG_"} then {
            set statuszeile "'Linke Maustaste' vergroessert Radius \
der Gangpolkurve, 'Rechte Maustaste' verkleinert ihn"
        } elseif {$ibind == "K"} then {
            set statuszeile "'Linke Maustaste' vergroessert Abstand \
des Punktes, 'Rechte Maustaste' verkleinert ihn"
        } elseif {$irunMaxI > 0} then {
#	    set statuszeile \
	    "'Rechte oder Linke Maustaste' halten Getriebe an"
	} else {
#           set statuszeile "'Rechte Maustaste' startet Getriebe im \
Uhrzeigersinn, 'Linke Maustaste' im Gegenuhrzeigersinn"
	}
}
#############################################################
proc T_Bind {wc} {
    global rB_ rG_ a_ m_ iN gamma0_ Pi statuszeile gam0_grad
    global phi_ a_massstab massstab iN_A iZ_A Pi showTrochMove 
    global showFelder
    global xMoveto last_xMoveto 0x last_0x xregion_
    global yMoveto last_yMoveto 0y last_0y yregion_
    global last_massstab

    foreach ibind {rR rG_ K Trochoide} {
        $wc bind $ibind <Any-Enter> "TEnterrRrGKorTrochoide $ibind $wc"
        $wc bind $ibind <Any-Leave> "TLeaverRrGKorTrochoide $ibind $wc"
    }
#   $wc bind Trochoide <Button-1> { TRunTrochoide -1 1}
#   $wc bind Trochoide <Button-3> { TRunTrochoide +1 1}

    $wc bind rast <Any-Enter> {
        $wc itemconfigure rast -width 2
    }
    $wc bind rast <Any-Leave> {
        $wc itemconfigure rast -width 1
    }
    $wc bind gang <Any-Enter> {
        $wc itemconfigure gang -width 2
        set statuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die Gangpolkurve"
    }
    $wc bind gang <Any-Leave> {
        $wc itemconfigure gang -width 1
#        TSetrRrGwidth2
        set statuszeile " "
    }
    $wc bind gang <Button-1> {
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        if {$showFelder==1} then {TSetSchnittBlue}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind gang <Button-3> {
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        if {$showFelder==1} then {TSetSchnittBlue}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind ball <Any-Enter> {
        $wc itemconfigure ball -width 2
        set statuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
    }
    $wc bind ball <Any-Leave> {
        $wc itemconfigure ball -width 1
        set statuszeile " "
    }
$wc bind t <Any-Enter> {
        $wc itemconfigure t -width 2
        set statuszeile "Mit 'Linker' bzw. 'rechter Maustaste' kann der \
 die Trochoide erzeugende Punkt bewegt werden"
    }
    $wc bind t <Any-Leave> {
        $wc itemconfigure t -width 1
        set statuszeile " "
    }
    $wc bind t <ButtonPress-1> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
    }
    $wc bind t <B1-Motion> {
        VerschiebeKnoten $wc 4 [expr %x-$xPos] [expr %y-$yPos]
        set xPos %x
        set yPos %y
        if {$showTrochMove == 1} then {
            set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set xG [expr $rG_*$m_*cos($phi_)]
            set yG [expr $rG_*$m_*sin($phi_)]
            set dx [expr $xPos-$xG-( $xPosT-$x)]
            set dy [expr $yPos-$yG-($yPosT-$y)]
            set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
            set winkel_neu [expr atan2($dy,$dx)]
            set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
            set gam0_grad [expr $gamma0_*180./$Pi]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
           set xPosT $xPos
           set yPosT $yPos
        }
    }
    $wc bind t <ButtonRelease-1> {
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set dx [expr $xPos-$xG-( $xPosT-$x)]
        set dy [expr $yPos-$yG-($yPosT-$y)]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
        set winkel_neu [expr atan2($dy,$dx)]
        set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
        set gam0_grad [expr $gamma0_*180./$Pi]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind t <ButtonPress-3> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set xR [expr $x-$xG]
        set yR [expr $y-$yG]
#        set gamma [expr atan2(($y-$yG),($x-$xG))]
        if {$yR > [expr $xR]} then {
                set follow "x"
        } else {
                set follow "y"
        }
    }
    $wc bind t <B3-Motion> {
        if {$follow == "x"} then {
            set dx [expr %x-$xPos] 
            VerschiebeKnoten $wc 4 $dx [expr $dx/$xR*$yR]
        } else {
            set dy [expr %y-$yPos]
            VerschiebeKnoten $wc 4 [expr $dy*$xR/$yR] $dy
        }
        set xPos %x
        set yPos %y

        if {$showTrochMove == 1} then {
            set dx [expr $xPos-$xG-[expr $xPosT-$x]]
            set dy [expr $yPos-$yG-[expr $yPosT-$y]]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        }
    }
    $wc bind t <ButtonRelease-3> {
        set dx [expr $xPos-$xG-[expr $xPosT-$x]]
        set dy [expr $yPos-$yG-[expr $yPosT-$y]]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind ball <Button-1> {
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind ball <Button-3> {
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind rG_ <Button-1> {
        set iN_A [expr $iN_A+1]
        TSetI
        calculatePara $iZ $iN $rR
        calculateKueKb $wc $iN $iZ $Pi $rR
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
        setGetriebetyp $iZ $iN 
    }
    $wc bind rG_ <Button-3> {
        if {$iN_A>1} {
	    set iN_A [expr $iN_A-1]
            TSetI
	    calculatePara $iZ $iN $rR
       	    calculateKueKb $wc $iN $iZ $Pi $rR
            modifyGetriebe $wc $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind rR <Button-1> {
        set iZ_A [expr $iZ_A+1]
        TSetI
        modifyGetriebe $wc $rR
        calculatePara $iZ $iN $rR
        calculateKueKb $wc $iN $iZ $Pi $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind rR <Button-3> {
        if {$iZ_A>1} {
	    set iZ_A [expr $iZ_A-1]
            TSetI
            modifyGetriebe $wc $rR
	    calculatePara $iZ $iN $rR
            calculateKueKb $wc $iN $iZ $Pi $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind K <Button-1> {
        set da [expr $a_*0.1]
        set a_ [expr $a_+$da]
        set a_massstab [expr $a_/$massstab]
        if {$showFelder==1} then {TSetSchnittBlue}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind K <Button-3> {
        set da [expr $a_*0.1]
        set a_ [expr $a_-$da]
        set a_massstab [expr $a_/$massstab]
        if {$showFelder==1} then {TSetSchnittBlue}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    bind .chscroll <ButtonRelease-1> {
	set last_xMoveto $xMoveto
	set last_0x $0x
	set last_massstab $massstab
	set list [.chscroll get]
        set xMoveto [lrange $list 0 0]
        $wc xview moveto $xMoveto
	set 0x [expr $0x-($xMoveto-$last_xMoveto)*$xregion_]
    }
    bind .cvscroll <ButtonRelease-1> {
	set last_yMoveto $yMoveto
	set last_0y $0y
	set last_massstab $massstab
	set list [.cvscroll get]
        set yMoveto [lrange $list 0 0]
        $wc yview moveto $yMoveto
	set 0y [expr $0y-($yMoveto-$last_yMoveto)*$yregion_]
    }
}
#############################################################
proc T_Status {w} {
    global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
    global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
    global showFelder statuszeile

    set ww $w
    frame $ww.t
    pack $ww.t -fill x -in $w -side top -anchor n

    label $ww.t.l1 -text "TYP:"
    pack $ww.t.l1 -in $ww.t -side left

    menubutton $ww.t.m -text "?" -menu $ww.t.m.menu -relief raised
    pack $ww.t.m -in $ww.t -side right
    menu $ww.t.m.menu
    $ww.t.m.menu add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType
    tk_menuBar $ww.t.m
    focus $ww.t.m

    label $ww.t.l2 -textvariable type_ -width 12
    pack $ww.t.l2 -in $ww.t -side right


    frame $ww.r
    pack $ww.r -fill x -in $w -side top -anchor n

    label $ww.r.l1 -text "r" -bd 0
    pack $ww.r.l1 -in $ww.r -side left -anchor c
    label $ww.r.l2 -text "R" -bd 0
    pack $ww.r.l2 -in $ww.r -side left -anchor s
    label $ww.r.l3 -text "=" -bd 0
    pack $ww.r.l3 -in $ww.r -side left -anchor c
    button $ww.r.iZ- -text "<" -command {
	set change "ok"
	if {$iZ_A == 1} then {set change "not ok"}
                if {$type_ == "Hypotrochoide"} then {
	    if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A-1]}
	TSetI
    }
    entry $ww.r.e1 -width 4 -textvariable iZ_A
    bind $ww.r.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iZ_A >= $iN_A} then {set iZ_A [expr $iN_A-1]}
        }
        if {$type_ == "Hypotrochoide"} then {
            if {$iZ_A <= $iN_A} then {set iZ_A [expr $iN_A+1]}
        }
        TSetI
    }
    button $ww.r.iZ+ -text ">" -command {
	set change "ok"
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A+1]}
	TSetI
    }
    pack $ww.r.iZ+ $ww.r.e1 $ww.r.iZ- -in $ww.r -side right

     bind $ww.r <Any-Enter> {TRaiserRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground red}
     bind $ww.r <Any-Leave> {TLeaverRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground black}

    frame $ww.g
    pack $ww.g -fill x -in $w -side top -anchor n

    label $ww.g.l1 -text "r" -bd 0
    pack $ww.g.l1 -in $ww.g -side left -anchor c
    label $ww.g.l2 -text "G" -bd 0
    pack $ww.g.l2 -in $ww.g -side left -anchor s
    label $ww.g.l3 -text "=" -bd 0
    pack $ww.g.l3 -in $ww.g -side left -anchor c
    button $ww.g.iN- -text "<" -command {
                set change "ok"
	if {$iN_A == 1} then {set change "not ok"}
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iN_A [expr $iN_A-1]}
	TSetI
    }
    entry $ww.g.e1 -width 4 -textvariable iN_A
    bind $ww.g.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iN_A <= $iZ_A} then {set iN_A [expr $iZ_A+1]}
        }
        if {$type_ == "Hypotrochoide"} then {
            if {$iN_A >= $iZ_A} then {set iN_A [expr $iZ_A-1]}
        }
        TSetI
    }
    button $ww.g.iN+ -text ">" -command {
	set change "ok"
                if {$type_ == "Hypotrochoide"} then {
	    if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iN_A [expr $iN_A+1]}
	TSetI
    }
    pack $ww.g.iN+ $ww.g.e1 $ww.g.iN- -in $ww.g -side right

    bind $ww.g <Any-Enter> {TRaiserRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground red}
    bind $ww.g <Any-Leave> {TLeaverRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground black}

    frame $ww.rg
    pack $ww.rg -fill x -in $w -side top -anchor n

    label $ww.rg.l1 -text "r" -bd 0
    pack $ww.rg.l1 -in $ww.rg -side left -anchor n
    label $ww.rg.l2 -text "R" -bd 0
    pack $ww.rg.l2 -in $ww.rg -side left -anchor s
    label $ww.rg.l3 -text "/" -bd 0
    pack $ww.rg.l3 -in $ww.rg -side left -anchor n
    label $ww.rg.l4 -text "r" -bd 0
    pack $ww.rg.l4 -in $ww.rg -side left -anchor n
    label $ww.rg.l5 -text "G" -bd 0
    pack $ww.rg.l5 -in $ww.rg -side left -anchor s
    label $ww.rg.l6 -text "=  i  =" -bd 0
    pack $ww.rg.l6 -in $ww.rg -side left -anchor n

    label $ww.rg.l7 -textvariable iZ_M
    label $ww.rg.l8 -text "/"
    label $ww.rg.l9 -textvariable iN_M
    pack $ww.rg.l7 $ww.rg.l8 $ww.rg.l9 -in $ww.rg -side right

    frame $ww.s
    pack $ww.s -fill x -in $w -side top -anchor n

    label $ww.s.l1 -text "Anzahl Schleifen:"
    pack $ww.s.l1 -in $ww.s -side left
    label $ww.s.l2 -textvariable iZ_M
    pack $ww.s.l2 -in $ww.s -side right

    frame $ww.us
    pack $ww.us -fill x -in $w -side top -anchor n

    label $ww.us.l1 -text "Stegumlaeufe pro Periode:"
    pack $ww.us.l1 -in $ww.us -side left
    label $ww.us.l2 -textvariable iN_M
    pack $ww.us.l2 -in $ww.us -side right

    frame $ww.a
    pack $ww.a -fill x -in $w -side top -anchor n

    label $ww.a.l1 -text "M" -bd 0
    pack $ww.a.l1 -in $ww.a -side left -anchor n
    label $ww.a.l2 -text "G" -bd 0
    pack $ww.a.l2 -in $ww.a -side left -anchor s
    label $ww.a.l3 -text "- K  =" -bd 0
    pack $ww.a.l3 -in $ww.a -side left -anchor n
    entry $ww.a.e -textvariable a_massstab -width 10
    bind $ww.a.e <Return> {set a_ [expr $a_massstab*$massstab]
#        TSetI
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
        TSetSchnittBlue}
    pack $ww.a.e -in $ww.a -side right

    bind $ww.a <Any-Enter> {TRaiserRrGKorTrochoide K $wc
        $ww.a.e configure -foreground red}
    bind $ww.a <Any-Leave> {TLeaverRrGKorTrochoide K $wc
         $ww.a.e configure -foreground black}

    frame $ww.phi
    pack $ww.phi -fill x -in $w -side top -anchor n

    label $ww.phi.l1 -text "Phi" -bd 0
    pack $ww.phi.l1 -in $ww.phi -side left -anchor n
    label $ww.phi.l2 -text " in " -bd 0
    pack $ww.phi.l2 -in $ww.phi -side left -anchor n
    label $ww.phi.l3 -text "Grad" -bd 0
    pack $ww.phi.l3 -in $ww.phi -side left -anchor n
    label $ww.phi.l4 -text " =" -bd 0
    pack $ww.phi.l4 -in $ww.phi -side left -anchor n
    entry $ww.phi.e -textvariable phi_grad -width 10
    bind $ww.phi.e <Return> {
        set phi_ [expr $phi_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    pack $ww.phi.e -in $ww.phi -side right

frame $ww.gam
    pack $ww.gam -fill x -in $w -side top -anchor n

    label $ww.gam.l1 -text "Gamma" -bd 0
    pack $ww.gam.l1 -in $ww.gam -side left -anchor n
     label $ww.gam.l2 -text "0" -bd 0
    pack $ww.gam.l2 -in $ww.gam -side left -anchor s
    label $ww.gam.l3 -text " in " -bd 0
    pack $ww.gam.l3 -in $ww.gam -side left -anchor n
    label $ww.gam.l4 -text "Grad" -bd 0
    pack $ww.gam.l4 -in $ww.gam -side left -anchor n
    label $ww.gam.l5 -text " =" -bd 0
    pack $ww.gam.l5 -in $ww.gam -side left -anchor n
    entry $ww.gam.e -textvariable gam0_grad  -width 10
    bind $ww.gam.e <Return> {
        set gamma0_ [expr $gam0_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    pack $ww.gam.e -in $ww.gam -side right
    TStatusFelder 
}
####################################################
proc TStatusFelder {} {
     global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
     global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
     global showFelder statuszeile kueStatus nW_

     destroy $ww.b
     destroy $ww.b.l1
     destroy $ww.b.l2
     destroy $ww.b.l3

     if {$showFelder == 1} then {
         frame $ww.b
         pack $ww.b -fill x -in $ww -side top -anchor n

        label $ww.b.l1 -text "r" -bd 0
        pack $ww.b.l1 -in $ww.b -side left -anchor n
        label $ww.b.l2 -text "B  =" -bd 0
        pack $ww.b.l2 -in $ww.b -side left -anchor s
        label $ww.b.l3 -textvariable rB_massstab
        pack $ww.b.l3 -in $ww.b -side right

        bind $ww.b <Any-Enter> {
            $wc itemconfigure ball -width 2
            if {$showFelder == 1} then {
                set statuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
               $ww.b.l3 configure -relief raised
            } else {
                set statuszeile " "
            }
        }
        bind $ww.b <Any-Leave> {
            $wc itemconfigure ball -width 1
            set statuszeile " "
            if {$showFelder == 1} then {
                $ww.b.l3 configure -relief flat
            }
        }
        bind $ww.b.l3 <Button-1> {
            set a_ [expr $rB_]
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
            TSetSchnittBlue
        }
    }

    destroy $ww.g2
    destroy $ww.g2.l1
    destroy $ww.g2.l2
    destroy $ww.g2.l3

    frame $ww.g2
    pack $ww.g2 -fill x -in $ww -side top -anchor n

    label $ww.g2.l1 -text "r" -bd 0
    pack $ww.g2.l1 -in $ww.g2 -side left -anchor n
    label $ww.g2.l2 -text "G  =" -bd 0
    pack $ww.g2.l2 -in $ww.g2 -side left -anchor s
    label $ww.g2.l3 -textvariable iN
    pack $ww.g2.l3 -in $ww.g2 -side right

    bind $ww.g2 <Any-Enter> {
        $wc itemconfigure gang -width 2
        set statuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die Gangpolkurve"
        $ww.g2.l3 configure -relief raised
    }
    bind $ww.g2 <Any-Leave> {
        $wc itemconfigure gang -width 1
        set statuszeile " "
        $ww.g2.l3 configure -relief flat
    }
    bind $ww.g2.l3 <Button-1> {
        set a_ [expr $rG_]
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
        TSetSchnittBlue
    }

    destroy $ww.ns
    destroy $ww.k
    destroy $ww.k.l1
    destroy $ww.k.l2
    destroy $ww.ue
    destroy $ww.w

     if {$showFelder == 1} then {
 
# Uebergangskurven
        frame $ww.k
        pack $ww.k -fill x -in $ww -side top -anchor n

        label $ww.k.l1 -text "Anzahl Uebergangskurven:"
        pack $ww.k.l1 -in $ww.k -side left
        label $ww.k.l2 -textvariable rUe_(0)
        pack $ww.k.l2 -in $ww.k -side right

# Frame fuer Uebergangskurven
        frame $ww.ue
        pack $ww.ue -fill x -in $ww -side top -anchor n

        if {$kueStatus == "ok"} then {T_KueStatus }

        frame $ww.w
        pack $ww.w -fill x -in $ww -side top -anchor n

        label $ww.w.l1 -text "Anzahl Wendepunkte" -anchor w
        pack $ww.w.l1 -in $ww.w -side left
        label $ww.w.l4 -textvariable nW_ -bd 0
        pack $ww.w.l4 -in $ww.w -side right
        label $ww.w.l3 -text "," -bd 0
        pack $ww.w.l3 -in $ww.w -side right
        label $ww.w.l2 -text "0" -bd 0
        pack $ww.w.l2 -in $ww.w -side right

# Frame fuer Schnittpunkt
        frame $ww.ns
        pack $ww.ns -fill x -in $ww -side top -anchor n
    }

# Frame fuer Copyright
    destroy $ww.fc

    frame $ww.fc
    pack $ww.fc -fill x -in $ww -side bottom -anchor s
    label $ww.fc.l1 -text "Copyright: 99, 00, 02" -bd 0 -foreground blue
    label $ww.fc.l2 -text "Volker Jaekel" -bd 0
    label $ww.fc.l3 -text "Pfingstweide 4" -bd 0
    label $ww.fc.l4 -text "D 35580 Wetzlar" -bd 0
    label $ww.fc.l5 -text "Germany" -bd 0
    pack $ww.fc.l5 -in $ww.fc -side bottom 
    pack $ww.fc.l4 $ww.fc.l3 $ww.fc.l2 \
	-in $ww.fc -side bottom 
    pack $ww.fc.l1 -in $ww.fc -side bottom -anchor w

}
#############################################################
proc T_KueStatus {} {
    global  rUe_ massstab Pi wc ww kueStatus

    set w $ww.ue
    set kueStatus "ok"

    destroy $w.f
    destroy $w.fc
    destroy $w.f.k1

    frame $w.f
    pack $w.f -fill x -in $w -side top

    set i 1
    while {$i <= $rUe_(0)} {
        set rkUe [expr $rUe_($i)/$massstab]
        frame $w.f.k$i
        pack $w.f.k$i -fill x -in $w.f -side top -anchor n
        label $w.f.k$i.l1 -text "r" -bd 0
        pack $w.f.k$i.l1 -in $w.f.k$i -side left -anchor n
        label $w.f.k$i.l2 -text "Ue$i" -bd 0
        pack $w.f.k$i.l2 -in $w.f.k$i -side left -anchor s
        label $w.f.k$i.l3 -text "=" -bd 0
        pack $w.f.k$i.l3 -in $w.f.k$i -side left -anchor n
        label $w.f.k$i.l4 -text $rkUe
        pack $w.f.k$i.l4 -in $w.f.k$i -side right

        bind $w.f.k$i <Any-Enter> \
	    "TBindUeIn $i $wc
	    $w.f.k$i.l4 configure -relief raised"
        bind $w.f.k$i <Any-Leave> \
	    "TBindUeOut $i $wc
	    $w.f.k$i.l4 configure -relief flat"
       bind $w.f.k$i.l4 <Button-1> \
	    "setAkUe $rUe_($i) $wc $Pi"
        
        set i [expr $i+1]
    }

    T_SchnittStatus $ww
}
############################################################
proc T_SchnittStatus {ww} {
    global ns0_ ns_ nsUe_ rUe_

    set w $ww.ns

    destroy $w.nsl1
    label $w.nsl1 -text "Anzahl Selbstschnitt-"
    pack $w.nsl1 -in $w -side top -anchor w

    destroy $w.f
    frame $w.f
    pack $w.f -fill x -in $w -side top

    destroy $w.l2
    label $w.l2 -text "punkte"
    pack $w.l2 -in $w.f -side left

    set i $rUe_(0)
    while {$i >= 1} {
        destroy $w.u$i
        label $w.u$i -text "$nsUe_($i)" -bd 0
        pack $w.u$i -in $w.f -side right
        destroy $w.k$i
        label $w.k$i -text "," -bd 0
        pack $w.k$i -in $w.f -side right
        set i [expr $i-1]
    }

    destroy $w.s2
    label $w.s2 -textvariable ns_ -bd 0
    pack $w.s2 -in $w.f -side right
    destroy $w.l3
    label $w.l3 -text "," -bd 0
    pack $w.l3 -in $w.f -side right
    destroy $w.s1
    label $w.s1 -textvariable ns0_ -bd 0
    pack $w.s1 -in $w.f -side right
}
#############################################################
proc TSetI {} {
    global iN_A iZ_A iZ iN type_ rR rG_ massstab iZ_M iN_M
    global wc gamma0_ Pi m_ a_ a_massstab

# Bruch kuerzen
    set iN_M $iN_A
    set iZ_M $iZ_A
    set try "ok"
    set i 1
    while {$try == "ok"} {
        set i [expr $i+1]
        if {($i <= $iN_M) && ($i <= $iZ_M)} then {
            if {$iN_M%$i == 0} then {
	if {$iZ_M%$i == 0} then {
	    set iZ_M [expr $iZ_M/$i]
	    set iN_M [expr $iN_M/$i]
	    set i 1
	}
            }
        } else {
            set try "not ok"
        }
    }

# Vorzeichen behaftete Uebersetzung ermitteln
    if {$type_ == "Epitrochoide"} then {
	set iZ [expr double($iZ_M)]
	set iN [expr double($iN_M)]
    } elseif {$type_ == "Peritrochoide"} then {
	set iN [expr double(-$iN_M)]
	set iZ [expr double($iZ_M)]
    } else {
	set iN [expr double($iN_M)]
	set iZ [expr double(-$iZ_M)]
    }

#Getriebegroesse ermitteln
    set rR [expr $iZ_M*$massstab]

    calculatePara $iZ $iN $rR
    calculateKueKb $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN

}
#############################################################
proc TShowGestell {} {
    global wc showGestell

    if {$showGestell == 1} then {
	TCreateGestellGelenk
	TCreateGestellRast
    } else {
 	$wc delete "Gestell"
 	$wc delete "gestell"
    }
}
#############################################################
proc TCreateGestellGelenk {} {
    global pradi_ wc

    $wc create line [expr -$pradi_/2.] $pradi_ \
	[expr -$pradi_*1.5] [expr $pradi_*3] -tag Gestell -fill brown
    $wc create line [expr -$pradi_*2.5] [expr $pradi_*3] \
	[expr $pradi_*2.5] [expr $pradi_*3] -tag Gestell -fill brown
    $wc create line [expr $pradi_*1.5] [expr $pradi_*3] \
	[expr $pradi_/2.] $pradi_ -tag Gestell -fill brown
    $wc create line [expr -$pradi_*0.75] [expr $pradi_*3] \
	[expr -$pradi_*2.25] [expr $pradi_*4.5] -tag Gestell \
	-fill brown
    $wc create line [expr $pradi_*0.25] [expr $pradi_*3] \
	[expr -$pradi_*1.25] [expr $pradi_*4.5] -tag Gestell \
	-fill brown
    $wc create line [expr $pradi_*1.25] [expr $pradi_*3] \
	[expr -$pradi_*0.25] [expr $pradi_*4.5] -tag Gestell \
	-fill brown
    $wc addtag "Knoten" withtag Gestell
}
#############################################################
proc TCreateGestellRast {} {
    global pradi_ wc type_ showGestell rR Pi

    if {$type_ == "Epitrochoide" || $type_ == "Peritrochoide"} then {
	set sign 1.
    } else {
	set sign -1.
    }

    set delta [expr 1.5*$pradi_]
    set y2 [expr $rR*cos(45.*$Pi/180.)]
    set x2 [expr -$y2]
    set y1 [expr $y2-$pradi_/2.]
    set x1 [expr -sqrt($rR*$rR-$y1*$y1)]
    set y3 [expr $y2+$pradi_/2.]
    set x3 [expr -sqrt($rR*$rR-$y3*$y3)]

    $wc create line $x2 $y2 \
	[expr $x2+$sign*$delta] [expr $y2-$sign*$delta] \
	-tag gestell -fill brown
    $wc create line $x1 $y1 \
	[expr $x1+$sign*$delta] [expr $y1-$sign*$delta] \
	-tag gestell -fill brown
    $wc create line $x3 $y3 \
	[expr $x3+$sign*$delta] [expr $y3-$sign*$delta] \
	-tag gestell -fill brown

    $wc addtag "Knoten" withtag gestell
}
#################################################################
proc VkueSpeichern {file} {
     # dummy-Unterprogramm
}
#############################################################
proc VGrafikeinstellungSpeichern3 {filename {append "no"}} {

    global showTrochMove 1
    global showFelder 1
    global showGestell 1
    global ischritte_ 
    global iT

    if {$append == "append"} then {
	set mod "a+"
    } else {
	set mod "w+"
    }
    set Datei [open $filename $mod]
	puts $Datei "set showTrochMove $showTrochMove"
	puts $Datei "set showFelder $showFelder"
	puts $Datei "set showGestell $showGestell"
	puts $Datei "set ischritte_ $ischritte_"
	puts $Datei "set iT $iT"
    close $Datei
}
#############################################################
proc VGetriebeparameterSpeichern  {filename {append "no"}} {

    global phi_ phi_grad gamma0_ gam0_grad a_ da pradi_ iZ iN iZ_A iN_A
    global rG_ rR type_ a_massstab

    set Datei [open $filename w+]
	puts $Datei "set phi_ $phi_"
	puts $Datei "set phi_grad $phi_grad"
	puts $Datei "set gamma0_ $gamma0_"
	puts $Datei "set gam0_grad $gam0_grad"
	puts $Datei "set a $a_"
	puts $Datei "set a_massstab $a_massstab"
	puts $Datei "set da $da"
	puts $Datei "set pradi_ $pradi_"
	puts $Datei "set iZ $iZ"
	puts $Datei "set iN $iN"
	puts $Datei "set iZ_A $iZ_A"
	puts $Datei "set iN_A $iN_A"
	puts $Datei "set rG_ $rG_"
	puts $Datei "set rR $rR"
	puts $Datei "set type_ $type_" 
    close $Datei
}
############################################################
proc VupdateView {} {

    global a a_ iZ_M iZ_A iN_M iN_A iZ iN rR
    global wc m_ gamma0_ Pi 

    set a_ $a
    set iZ_M $iZ_A
    set iN_M $iN_A

    calculatePara $iZ $iN $rR

    calculateKueKb $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN


}
#############################################################

global a_ phi_ pradi_ rG_ i_ m_ gamma0_ iTyp_ iZ_A iN_A iN_M iZ_M
global iZ iN wc rR Pi irunMaxI xMax_ yMax_ massstab a_massstab
global statuszeile gam0_grad showTrochMove showFelder kueStatus 
global canvas_height canvas_width ischritte_ iT umdr_ phi_grad
global last_massstab xMoveto yMoveto 0x 0y last_0x last_0y
global showGestell plotName
global dromegTVers

set dromegTVers 1.2
set xMoveto .35
set yMoveto .35
set showTrochMove 1
set showFelder 1
set showGestell 1
set kueStatus "not ok"
set Pi [expr 4.*atan(1.)]
set umdr_ 0
#set iT 180
#set ischritte_ 360
set iT 3600
set ischritte_ 3600
set phi_ [expr -$Pi/6.]
set phi_grad [expr $phi_/$Pi*180.]
set gamma0_ 0
set gam0_grad 0
set a 40
set da 5
set pradi_ 5
set iZ 4.
set iN 1.
set iZ_A 4
set iN_A 1
set rG_ 20
set rR 80
set rUe_(0) 0
set type_ Epitrochoide

# dro-p-t.def einlesen

    set filename [speicherDir]
    append filename dro-p-t.def
    if {[file exists $filename] == 1} then {
        source $filename
    }

set a_ $a
set iZ_M $iZ_A
set iN_M $iN_A

calculatePara $iZ $iN $rR
set xMax_ [expr ($rG_*$m_+abs($a))+10]
set yMax_ [expr ($rG_*$m_+abs($a))+10]
set irunMaxI 0
set iTyp_ Epitrochoide
set massstab 20
set last_massstab 20
set a_massstab [expr $a_/$massstab]
set plotName "C:/temp/dromeg.ps"

# dromeg-t.def einlesen

    set filename [speicherDir]
    append filename dromeg-t.def
    if {[file exists $filename] == 1} then {
        source $filename
    }

set wc .canvas

if {[info exists canvas_height] == 0} then {
    set filename [speicherDir]
    append filename dromeg.def
    if {[file exists $filename] == 1} then {
        source $filename
    } else {
        #set canvas_height 350
        set canvas_height 500
        set canvas_width 630
        set plotName c:/temp/dromeg.eps
        #set canvas_width 400
    }
}

#set 0x [expr double($xregion_)/2.]
#set 0y [expr double($yregion_)/2.]
set 0x [expr $canvas_width/2.]
set 0y [expr $canvas_height/2.]
set last_0x 0x
set last_0y 0y
destroy .c
destroy .cvscroll
destroy .chscroll
destroy $wc
destroy .d
destroy .a- .aL .aE .a+
destroy .iN- .iNL .iNE .iN+ .iN0
destroy .iZ- .iZL .iZE .iZ+ .iZ0
destroy .s
TPullDownMenu
wm title . "DROMEG-T Version $dromegTVers (Freeware)"
    #"Die Uebergangskurven von Trochoiden erzeugenden Raedergetrieben"
#wm geometry . +10+5
wm geometry . +1+1
frame .c
pack .c -expand yes -fill both -padx 1 -pady 1

frame .c.f
pack .c.f -expand yes -fill y -in .c -side left

T_Grafik

T_Status .c.f

frame .s -background black
pack .s -in . -expand yes -fill x
label .s.statuszeile -textvariable statuszeile \
    -background black -foreground white
pack .s.statuszeile -in .s -fill x -side left
set statuszeile "Hier erscheinen Hinweise zur Programmbedienung \
   (z. B. wenn Sie den Mauszeige ueber eine Kurve legen)"

frame .d
pack .d -expand yes -fill both -padx 1 -pady 1

T_Bind $wc

Knoten $wc 0 0 rR
set xP [expr $rR*cos($phi_)]
set yP [expr $rR*sin($phi_)]
Knoten $wc $xP $yP rG_
set xG [expr $rG_*$m_*cos($phi_)]
set yG [expr $rG_*$m_*sin($phi_)]
Knoten $wc $xG $yG K
set y [yTrochoide $rG_ $m_ $phi_ $a $gamma0_]
set x [xTrochoide $rG_ $m_ $phi_ $a $gamma0_]
Knoten $wc $x $y t
#Knoten $wc $x $y Trochoide
#$wc addtag "t" withtag Trochoide
Kante $wc 1 2 rR rr
Kante $wc 2 3 rG_ rg_
Kante $wc 3 4 K k
Kante $wc 1 3 S s
$wc create oval [expr $xG-$rG_] [expr $yG-$rG_] \
        [expr $xG+$rG_] [expr $yG+$rG_] -outline black -fill yellow \
	-tags gang
$wc lower gang
$wc create oval [expr -$rR] [expr -$rR] $rR $rR -outline black \
	-fill lightgrey -tags rast
$wc lower rast

calculateKueKb $wc $iN $iZ $Pi $rR

$wc create oval [expr $xG-$rB_] [expr $yG-$rB_] \
        [expr $xG+$rB_] [expr $yG+$rB_] -outline red \
	-fill GreenYellow  -tags ball

TCreateGestellGelenk
TCreateGestellRast
createTrochoide $wc $iN $Pi
TLowerKurven

#fuer Vorfuehrung:
##################

#Vorfuehrung#set type_ Hypotrochoide 
TSetType

#Vorfuehrung#set iZ_A 5
#Vorfuehrung#set iN_A 1
TSetI

#Vorfuehrung#set a_massstab 1.5
set a_ [expr $a_massstab*$massstab]
modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
TSetSchnittBlue

#set showFelder 0
#TShowFeldeinteilung

focus $wc
